// Assign the correct pin to the buzzer
const byte BUZZER_PIN = 9;

// Define the correct frequencies for the buzzer to play in tune music
const int NOTE_C3 = 131;
const int NOTE_D3 = 147;
const int NOTE_E3 = 165;
const int NOTE_F3 = 175;
const int NOTE_G3 = 196;
const int NOTE_A3 = 220;
const int NOTE_B3 = 247;
const int NOTE_C4 = 262;
const int NOTE_D4b = 277;
const int NOTE_D4 = 294;
const int NOTE_E4b = 311;
const int NOTE_E4 = 330;
const int NOTE_F4 = 349;
const int NOTE_G4 = 392;
const int NOTE_A4 = 440;
const int NOTE_B4 = 494;
const int NOTE_C5 = 523;
const int NOTE_D5 = 587;
const int NOTE_E5 = 659;
const int NOTE_F5 = 698;
const int NOTE_G5 = 784;
const int NOTE_A5 = 880;
const int NOTE_B5 = 988;

// Class music to hold the frequency and duration of the notes and be able to play themn
class Music 
{
private:
  int* notes;
  int* durations;
  int length;

public:
  // Initialise th class
  Music(int _length, int* _notes, int* _durations)
  {
    length = _length;
    notes = _notes;
    durations = _durations;
  }
  
  // Free up the memory of the pointers to prevent memory leaks
  ~Music() 
  { 
    free(notes);
    notes = NULL; 
    free(durations);
    durations = NULL;
  }

  // Loop through all the notes and durations to play in order
  Play() {
    for (int i = 0; i < length; i++)
    {
      tone(BUZZER_PIN, notes[i], durations[i]);
      delay(durations[i]);
    }
  }
};

// Define Win music
int winNotes[] = { NOTE_C5, NOTE_E5, 0, NOTE_G5, NOTE_E5, 0, NOTE_G5 };
int winDurations[] = { 160, 80, 40, 160, 80, 40, 480 };
Music winMusic(7, winNotes, winDurations);

// Define Lose music
int loseNotes[] = { NOTE_E4, NOTE_E4b, NOTE_D4, NOTE_D4b, NOTE_C4};
int loseDurations[] = { 320, 320, 320, 320, 1280 };
Music loseMusic(5, loseNotes, loseDurations);

